import { readdir as q, readFile as T, writeFile as M } from "fs/promises";
import { existsSync as C, mkdirSync as D } from "fs";
import { normalize as E, join as K, extname as F } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function Q(s, e = 0) {
  const n = [], u = [], f = [];
  let c = "", o = e;
  const p = (r) => (e = o, { type: r, value: w(), position: { start: e, end: o } }), x = (r) => {
    r.value = w(), r.position.start = e, r.position.end = o;
  }, b = () => s[++o], A = () => o < s.length - 1 ? s[o + 1] : "", P = () => o > 0 ? s[o - 1] : "", w = () => s.substring(e, o + 1), j = (r) => /["'`0-9+-]/.test(r), S = (r) => /[a-zA-Z_$]/.test(r), v = (r) => /[(){},:;.[\]?!=<>]/.test(r), g = (r) => /\//.test(r) && /\*/.test(A()), $ = (r, l) => {
    if (!l)
      l = p("Literal"), n.push(l);
    else {
      if (f.length === 0 && !/[0-9.]/.test(r))
        return y(r);
      x(l);
    }
    return f.length === 0 && /["'`]/.test(r) ? f.push(r) : f.length > 0 && f[f.length - 1] === r && (/\\/.test(P()) || f.pop()), $(b(), l);
  }, t = (r, l) => {
    if (!l)
      c = r, l = p("Identifier"), n.push(l);
    else if (/[0-9a-zA-Z_$. ]/.test(r))
      c += r, (c == "null" || c == "undefined" || c == "true" || c == "false" || c == "void 0") && (l.type = "Literal"), x(l);
    else
      return y(r);
    return t(b(), l);
  }, a = (r, l) => (l = p("Punctuator"), n.push(l), /\(/.test(r) ? u.push(r) : /\)/.test(r) && u.pop(), y(b())), i = (r) => /\//.test(r) && /\*/.test(P()) ? y(r) : i(b()), d = () => n[n.length - 1]?.type === "Punctuator" && u.length === 0 || o === s.length, y = (r = s[o]) => d() ? n : j(r) ? $(r) : S(r) ? t(r) : v(r) ? a(r) : g(r) ? i(r) : y(b());
  return y();
}
function W(s, e, n) {
  let u, f = 0;
  const c = [], o = () => f < s.length - 1 ? s[f + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, p = () => s[++f], x = () => s[s.length - 1], b = (t) => t.replace(/^["'`]|["'`]$/g, ""), A = (t) => (u.arguments.push({ type: "Literal", value: b(t.value) }), g(p())), P = (t) => (u.arguments.push({ type: "Identifier", value: t.value }), g(p())), w = (t, a, i) => (i || (i = {
    type: "Property",
    key: { type: "Identifier", value: t.value },
    value: { type: "Literal", value: "" }
  }, a.push(i)), !/^:$/.test(t.value) && !/^:$/.test(o().value) ? t.type === "Literal" ? (i.value.value = b(t.value), S(p(), a)) : (i.value.type = "Expression", j(t, a, i)) : w(p(), a, i)), j = (t, a, i) => (i.value.value += t.value, /^[({]$/.test(t.value) ? c.push(t.value) : /^[)}]$/.test(t.value) && c.pop(), /^[,}]$/.test(o().value) && c.length === 0 ? S(p(), a) : j(p(), a, i)), S = (t, a) => (a || (a = [], u.arguments.push({ type: "ObjectExpression", properties: a })), /^}$/.test(t.value) ? g(p()) : /^:$/.test(o().value) ? w(t, a) : S(p(), a)), v = (t, a) => (a || (a = [], u.arguments.push({ type: "ArrayExpression", elements: a })), /^]$/.test(t.value) ? g(p()) : (t.type === "Literal" && a.push({ type: "Literal", value: b(t.value) }), t.type === "Identifier" && a.push({ type: "Identifier", value: t.value }), v(p(), a))), g = (t) => Object.is(t, x()) ? u : t.type === "Literal" ? A(t) : t.type === "Identifier" && /^\($/.test(o().value) ? $(t) : t.type === "Identifier" ? P(t) : /^{$/.test(t.value) ? S(t) : /^\[$/.test(t.value) ? v(t) : g(p()), $ = (t, a, i = t.position.start) => a ? /^\)$/.test(t.value) ? (a.value = e.substring(i, t.position.end + 1), g(p())) : $(p(), a, i) : new RegExp(n).test(t.value) ? (u = {
    type: "CallExpression",
    value: e.substring(i, x().position.end + 1),
    arguments: []
  }, g(p())) : (a = { type: "CallExpression", value: "" }, u.arguments.push(a), $(p(), a, i));
  return $(s[f]);
}
function Z(s, e) {
  const n = new RegExp(`${e}\\(`, "gs"), u = [];
  let f;
  for (; (f = n.exec(s)) !== null; )
    u.push(f.index);
  return u;
}
function J(s, e) {
  const n = [], u = Z(s, e);
  for (const f of u) {
    const c = Q(s, f);
    if (c.length > 0)
      try {
        const o = W(c, s, e);
        o && n.push(o);
      } catch (o) {
        console.error(o), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          s.substring(f, c[c.length - 1].position.end) + `
`
        );
      }
  }
  return n;
}
function _(s) {
  return /inlineTranslate/.test(s);
}
function G(s) {
  return /inlinePlural/.test(s);
}
function H(s) {
  let e = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function U(s) {
  let e = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function X(s) {
  return JSON.parse(s, (e, n) => n === null || n === "" ? void 0 : n);
}
function Y(s, e, n) {
  let u = 0;
  const f = e.length;
  for (; u < f; ) {
    const c = e[u++];
    s[c] = s[c] && !n ? s[c] : u === f ? n : typeof s[c] == "object" ? s[c] : {}, s = s[c];
  }
}
function N(s, e) {
  typeof s == "object" && typeof e == "object" && Object.keys(e).forEach((n) => {
    typeof e[n] == "object" ? n in s ? N(s[n], e[n]) : Object.assign(s, { [n]: e[n] }) : e[n] && Object.assign(s, { [n]: e[n] });
  });
}
function k(s, e) {
  typeof s == "object" && typeof e == "object" && Object.keys(e).forEach((n) => {
    typeof e[n] == "object" ? n in s ? k(s[n], e[n]) : Object.assign(s, { [n]: e[n] }) : !s[n] && e[n] && Object.assign(s, { [n]: e[n] });
  });
}
function ee(s) {
  return typeof s == "object" ? JSON.parse(JSON.stringify(s)) : s;
}
function te(s, e) {
  return s = { ...s, ...e }, s;
}
function se(s) {
  return JSON.stringify(s, ne, 2);
}
function R(s) {
  return Object.keys(s).sort().reduce(
    (e, n) => (typeof s[n] == "object" && !Array.isArray(s[n]) ? e[n] = R(s[n]) : e[n] = s[n], e),
    {}
  );
}
function ne(s, e) {
  return typeof e == "string" ? e.replace(/\\/g, "") : e;
}
function ae(s, e) {
  const n = /* @__PURE__ */ new Set();
  for (let u = 0; u < 20; u++) {
    const f = new Intl.PluralRules(s, e).select(u);
    n.add(f);
  }
  return Array.from(n);
}
function re(s) {
  let e;
  if (s) {
    e = {};
    for (const n of s)
      e = { ...e, [n.key.value]: n.value.value };
  }
  return e;
}
async function ue(s) {
  const e = {
    ...s,
    basePath: s.basePath ?? "./",
    sourceFilesPaths: s.sourceFilesPaths ?? ["src"],
    excludedPaths: s.excludedPaths ?? [],
    assetsPath: s.assetsPath ?? "i18n",
    format: s.format ?? "json",
    filename: s.filename ?? "app",
    fallback: s.fallback ?? ((t) => t),
    keySeparator: s.keySeparator ?? ".",
    keyValueSeparator: s.keyValueSeparator ?? "@@"
  }, n = /* @__PURE__ */ new Map(), u = e.sourceFilesPaths.map((t) => E(`${e.basePath}/${t}`)), f = e.excludedPaths.map((t) => E(`${e.basePath}/${t}`)), c = [];
  let o = Object.fromEntries(e.supportedLangs.map((t) => [t, {}]));
  const p = async (t, a) => {
    const i = await q(t, { withFileTypes: !0 });
    for (const d of i) {
      const y = K(t, d.name), r = F(d.name);
      d.isDirectory() ? a.includes(y) || await p(y, a) : /\.js|\.ts|\.jsx|\.tsx/.test(r) && !/test|spec/.test(d.name) && c.push(y);
    }
  }, x = (t) => t.type === "Identifier" || t.type === "Literal" && t.value && /\${.*}/.test(t.value) ? (n.set("dynamic", (n.get("dynamic") ?? 0) + 1), !0) : !1, b = async (t) => {
    const a = [];
    let i = await T(E(`${e.basePath}/${t}`), "utf8");
    const d = (r) => {
      i = i.replace(new RegExp(`${r}<.*>\\(`, "g"), `${r.replace("\\b", "")}(`);
    }, y = (r) => {
      for (const l of r) {
        const h = l.arguments;
        if (h?.length > 0) {
          if (h[0].type === "ArrayExpression") {
            if (h[0].elements) {
              for (const m of h[0].elements)
                if (m.type === "Literal") {
                  if (x(m))
                    continue;
                  a.push(m.value);
                }
            }
          } else if (h?.[0]?.value) {
            if (x(h[0]))
              continue;
            a.push(h[0].value);
          }
        }
      }
    };
    if (_(i)) {
      const r = H(i);
      if (r) {
        d(r);
        const l = J(i, r);
        y(l);
      }
    }
    if (G(i)) {
      const r = U(i);
      if (r) {
        const l = J(i, r);
        for (const h of l) {
          const m = h.arguments;
          if (m?.length > 0) {
            if (m[1]?.type === "Identifier" || m[1]?.type === "CallExpression" || m[3]?.type === "Identifier" || m[3]?.type === "CallExpression") {
              n.set("dynamic plural", (n.get("dynamic plural") ?? 0) + 1);
              continue;
            }
            const L = /* @__PURE__ */ new Set(), V = re(m[3]?.properties);
            for (const O of e.supportedLangs) {
              const I = ae(O, V);
              for (const z of I)
                L.add(z);
            }
            const B = m?.[1]?.value;
            if (B) {
              const O = {};
              for (const I of L)
                O[I] = "";
              a.push(`${B}${e.keyValueSeparator}${JSON.stringify(O)}`);
            } else
              for (const O of L)
                a.push(O);
          }
        }
      }
    }
    return a;
  }, A = async () => {
    const t = /* @__PURE__ */ new Map();
    for (const a of e.supportedLangs) {
      const i = E(`${e.basePath}/${e.assetsPath}/${a}`);
      if (C(i)) {
        const d = await q(i);
        if (d.length > 0) {
          const y = F(d[0]);
          let r = {};
          const l = d.map((m) => T(`${i}/${m}`, "utf8")), h = await Promise.all(l);
          for (const m of h)
            if (m) {
              let L = {};
              switch (y) {
                case ".json":
                  L = X(m);
                  break;
              }
              r = te(r, L);
            }
          t.set(a, r);
        }
      }
    }
    return t;
  }, P = async (t) => {
    for (const a of e.supportedLangs) {
      const i = E(`${e.basePath}/${e.assetsPath}/${a}`);
      C(i) || D(i, { recursive: !0 });
      const d = Object.keys(o[a]).filter((l) => !t.includes(l)), y = Object.keys(o[a]).filter((l) => t.includes(l)), r = {};
      o[a][e.filename] && (r[e.filename] = o[a][e.filename]);
      for (const l of y)
        r[l] = o[a][l];
      Object.keys(r).length > 0 && await w(r, e.filename, i);
      for (const l of d.filter((h) => h !== e.filename))
        await w({ [l]: o[a][l] }, l, i);
    }
  }, w = async (t, a, i) => {
    let d;
    switch (e.format) {
      case "json":
        d = se(t);
        break;
    }
    const y = E(`${i}/${a}.${e.format}`);
    await M(y, d), console.log(y);
  };
  for (const t of u)
    await p(t, f);
  const j = c.map((t) => b(t)), S = await Promise.all(j);
  let v = [];
  for (const t of S)
    v = v.concat(t);
  v = [...new Set(v)], n.set("unique keys", (n.get("unique keys") ?? 0) + v.length);
  const g = [];
  for (let t of v) {
    let a;
    [t, a] = t.split(e.keyValueSeparator), /^[[{].*[\]}]$/.test(a) && !/^{{/.test(a) && (a = JSON.parse(a));
    for (const i of e.supportedLangs)
      Y(o[i], t.split(e.keySeparator), ee(a || ""));
    g.push(t);
  }
  const $ = await A();
  if ($.size > 0)
    for (const [t, a] of $)
      N(o[t], a);
  for (const t of e.supportedLangs)
    o[t] = R(o[t]);
  o = e.fallback(o), await P(g);
  for (const [t, a] of n)
    switch (t) {
      case "unique keys":
        console.log("\x1B[32m%s\x1B[0m", `extracted keys: ${a}`);
        break;
      case "dynamic":
        console.log("\x1B[32m%s\x1B[0m", `translations skipped due to dynamic keys: ${a}`);
        break;
      case "dynamic plural":
        console.log("\x1B[32m%s\x1B[0m", `plurals skipped due to dynamic keys/options: ${a}`);
        break;
    }
}
export {
  k as deepMergeMissing,
  ue as qwikSpeakExtract
};
